package whiteship.crud.infrastructure.service {

	import mx.collections.ArrayCollection;

	import org.springextensions.actionscript.core.operation.IOperation;
	import org.springextensions.actionscript.core.operation.MockOperation;
	import whiteship.crud.domain.Todo;
	import whiteship.crud.domain.service.ITodoService;

	public class InMemoryTodoService implements ITodoService {

		private var _todoIndex:uint = 1;
		private var _todos:ArrayCollection;

		// --------------------------------------------------------------------
		//
		// Constructor
		//
		// --------------------------------------------------------------------

		public function InMemoryTodoService() {
			initEmployees();
		}

		// --------------------------------------------------------------------
		//
		// Implementation: IEmployeeService
		//
		// --------------------------------------------------------------------

		public function getTodos():IOperation {
			return new MockOperation(_todos);
		}

		public function saveTodo(todo:Todo):IOperation {
			if (todo.id == -1) {
				todo.id = _todoIndex++;
				_todos.addItem(todo);
			}
			return new MockOperation(todo);
		}

		public function deleteTodo(todo:Todo):IOperation {
			var numTodos:uint = _todos.length;

			for (var i:uint = 0; i<numTodos; i++) {
				if (todo == _todos[i]) {
					_todos.removeItemAt(i);
					break;
				}
			}

			return new MockOperation(true);
		}

		// --------------------------------------------------------------------
		//
		// Private Methods
		//
		// --------------------------------------------------------------------

		private function initEmployees():void {
			_todos = new ArrayCollection();
		}
	}
}