package whiteship.crud.presentation {

	import flash.events.Event;
	import flash.events.EventDispatcher;

	import whiteship.crud.domain.Todo;

	public class TodoDetailPresentationModel extends EventDispatcher {

		public static const COMMIT:String = "commit";

		public static const CANCEL:String = "cancel";

		// --------------------------------------------------------------------
		//
		// Private Variables
		//
		// --------------------------------------------------------------------

		private var _originalTodo:Todo;

		// --------------------------------------------------------------------
		//
		// Constructor
		//
		// --------------------------------------------------------------------

		public function TodoDetailPresentationModel(todo:Todo = null) {
			if (todo) {
				_originalTodo = todo;
				private::todo = todo.clone();
			} else {
				private::todo = new Todo();
			}
		}

		// --------------------------------------------------------------------
		//
		// Public Properties
		//
		// --------------------------------------------------------------------

		// ----------------------------
		// todo
		// ----------------------------

		private var m_todo:Todo;

		[Bindable(event="todoChange")]
		public function get todo():Todo {
			return m_todo;
		}

		private function set todo(value:Todo):void {
			if (value !== m_todo) {
				m_todo = value;
				dispatchEvent(new Event("todoChange"));
			}
		}

		// --------------------------------------------------------------------
		//
		// Public Methods
		//
		// --------------------------------------------------------------------

		public function commitChanges():void {
			// copy the changes back into the original employee if we were editing one
			if (_originalTodo) {
				_originalTodo.copyFrom(m_todo);
			}
			dispatchEvent(new Event(COMMIT));
		}

		public function cancelChanges():void {
			dispatchEvent(new Event(CANCEL));
		}
	}
}